(function ($) {

  var initialized;

  //-- Stops Drupal from loading JS multiple times
  function init() {
    if (!initialized) {
       initialized = true;

       //-- If this class is removed layout defaults to admin theme
       $('body').addClass('browser-developer-body');

       //-- Adds Iframe to see live updates
       $(function(){
          $("#preview-container").each(function(){
            $('<div class="browser-development-iframe"><iframe id="browser-development-iframe-id"  src="' + this.href + '" width = "500px" height = "500px"></iframe></div>').insertAfter(this);
          });
       });

       //-- Gets Iframe to scroll down the page
       $(window).scroll(function(){
         $(".browser-development-iframe").css({"margin-top": ($(window).scrollTop()) + "px", "margin-left":($(window).scrollLeft()) + "px"});
       });

       //-- Global variables
       var set_iframe_style_id=false

       //-- Adds CSS/SCSS to the Iframe header
       function autoPreview() {

         //-- Vars
         var iframe = $('#browser-development-iframe-id');
         var style_id = 'browser-developement-styles-id'

         //-- Added style id to iframe if it doesn't exisit
         if(set_iframe_style_id == false){

           set_iframe_style_id=true;
           iframe.contents().find('head').append('<style type="text/css" id="'+style_id+'"></style>');
         }

         //-- Finds all the css in all the textareas
         var css_string = ""
         $('#browser-development-container-component textarea').each(function () {
           css_string = css_string + $(this).val()
         })

         //-- Adds all the css strings to the Iframe
         var add_css = iframe.contents().find('#'+style_id);
         if (add_css.length) {
           add_css.html(css_string);
         }

       };

       //-- On keypress updates autoPreview (Iframe)
       $(document).on('keyup','#browser-development-container-component textarea', autoPreview);


//  $('#edit-preview-path').on('blur', function() {
 //   $preview.attr('src', drupalSettings.CSSEditor.frontPage.replace('?', '/' + $(this).val() + '?'));
 // });
   }
  }



  Drupal.behaviors.browser_development = {
    attach: function (context, settings) {
     'use strict';
      init();
    }
  };
})(jQuery);
